/*
    shoot_test Task
    无人机发射任务
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "module/config.h"
#include "module/shoot_control.h"
#include "component/lightbridge2_cmd.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
COMP_LIGHTBRIDGE2_CMD_t shoot_ctrl_cmd_rc;
Shoot_t shoot;
Shoot_CMD_t shoot_cmd;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_shoot_test(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / SHOOT_TEST_FREQ;

  osDelay(SHOOT_TEST_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
	Config_ShootInit();
	Shoot_Init(&shoot,&Config_GetRobotParam()->shoot_param,SHOOT_TEST_FREQ);
	Shoot_SetMode(&shoot,SHOOT_MODE_SINGLE);					//初始化一个模式
	
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
    shoot_cmd.online	=shoot_ctrl_cmd_rc.online;
	  shoot_cmd.ready	=shoot_ctrl_cmd_rc.shoot.ready;
	  shoot_cmd.firecmd	=shoot_ctrl_cmd_rc.shoot.firecmd;
	  
	  shoot.mode = shoot_ctrl_cmd_rc.mode;			//或者用遥控器随时切换模式；二选一
	  
	  Shoot_UpdateFeedback(&shoot);
	  Shoot_Control(&shoot,&shoot_cmd);
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}
